<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách quảnh lý đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="row">
            <div class="col-sm-12 text-center mt-2 mb-2">
                <h3 class="text-primary">Danh sách đơn hàng</h3>
            </div>
        </div>
        <div class="container jumbotron">
            <div class="row">
                <div class="col-sm-2">
                    <label for="">Trạng thái Order</label>
                </div>
                <div class="col-sm-3 form-group">
                    <select class="form-control" name="order" id="select-order">
                        <option value="0">---All---</option>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>
                    </select>
                </div>
                <div class="col-sm-2">
                    <label for="">Loại Pizza</label>
                </div>
                <div class="col-sm-3 form-group">
                    <select class="form-control" name="order" id="select-pizza">
                        <option value="0">---All---</option>
                        <option value="hawaii">Hawaii</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>

                    </select>
                </div>
                <div class="col-sm-2">
                    <button id="btn-filter" class="btn btn-success">Lọc</button>
                </div>
            </div>
        </div>
        <div class="row">
            <table id="user-table" class="table table-bordered table-hover table-striped text-center">
                <thead>
                    <th>Order Id</th>
                    <th>Kích cỡ combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước Uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và Tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng Thái</th>
                    <th>Chi tiết</th>
                </thead>
            </table>
        </div>
    </div>
    <!--Modal Detail-->
    <div id="modal-order-detail" class="modal fade" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header text-center">
              <h5 class="modal-title">Order Detail</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <form action="insert-user">
                  <div class="row form-group">
                      <div class="col-sm-4">
                          <label for="">Order Id</label>
                      </div>
                      <div class="col-sm-8">
                          <input id="inp-order-id" type="text" class="form-control" placeholder="Nhập Course Code">
                      </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Kích Cỡ combo</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-combo" type="text" class="form-control" placeholder="Nhập Course name">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Salad</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-salad" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Số lượng nước</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-so-luong-nuoc" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Sườn</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-suon" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Loại Pizza</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-loai-pizza" type="text"  min="0" class="form-control" placeholder="Nhập Price">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Đường kính</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-duong-kinh" type="text" class="form-control" placeholder="Nhập IsPopular">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Nước Uống</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-id-nuoc-uong" type="text" min="0" class="form-control" placeholder="Nhập Discount Price">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Thành tiền</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-thanh-tien" type="number" class="form-control" placeholder="Nhập Duration">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Họ và tên</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-ho-ten" type="text" class="form-control" placeholder="Nhập Level">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Số điện thoại</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-so-dien-thoai" type="text" class="form-control" placeholder="Nhập Cover Image">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Email</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-email" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Địa chỉ</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-dia-chi" type="text" class="form-control" placeholder="Nhập Teacher Photo">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Giảm giá</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-discount" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Voucher</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-voucher" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Trạng thái</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-trang-thai" type="text" class="form-control" placeholder="Nhập Teacher Name">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Lời nhắn</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-loi-nhan" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Ngày cập nhật</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-ngay-cap-nhat" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Ngày tạo</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-ngay-tao" type="text" class="form-control" placeholder="Nhập IsTrending">
                    </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button id="button-confirm" type="button" class="btn btn-success">Đồng ý</button>
              <button id="button-cancel" type="button" class="btn btn-secondary">Cancel</button>
            </div>
          </div>
        </div>
    </div>
</body>
<script>
    "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gCOL_NAME = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chitiet"];
    const gCOL_ORDER_ID = 0;
    const gCOL_KICH_CO = 1;
    const gCOL_LOAI_PIZZA = 2;
    const gCOL_NUOC_UONG = 3;
    const gCOL_THANH_TIEN = 4;
    const gCOL_HO_TEN = 5;
    const gCOL_SO_DIEN_THOAI = 6;
    const gCOL_TRANG_THAI = 7;
    const gCOL_DETAIL = 8;
    var gUserTable = $("#user-table").DataTable({
        columns: [
            {data: gCOL_NAME[gCOL_ORDER_ID]},
            {data: gCOL_NAME[gCOL_KICH_CO]},
            {data: gCOL_NAME[gCOL_LOAI_PIZZA]},
            {data: gCOL_NAME[gCOL_NUOC_UONG]},
            {data: gCOL_NAME[gCOL_THANH_TIEN]},
            {data: gCOL_NAME[gCOL_HO_TEN]},
            {data: gCOL_NAME[gCOL_SO_DIEN_THOAI]},
            {data: gCOL_NAME[gCOL_TRANG_THAI]},
            {data: gCOL_NAME[gCOL_DETAIL]},
        ],
        columnDefs: [
            {
                targets: gCOL_DETAIL,
                defaultContent: "<i id='btn-detail' class='fas fa-search' style='cursor:pointer;'></i>"
            }
        ]
    });
    var gObjectUserData = {
        user: [],
        filterUser: function(paramDataFilter){
            console.log(paramDataFilter);
            var vResult = [];
            vResult = this.user.filter(function(item){
                return (item.trangThai == paramDataFilter.trangThai || paramDataFilter.trangThai == 0) && (item.loaiPizza == paramDataFilter.loaiPizza || paramDataFilter.loaiPizza == 0);
            })
            return vResult;
        }
    };
    // Đôi tượng lưu Id và UserId 
    var gObjectId = {
        id: "",
        orderId: ""
    }
     /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", "#btn-detail", function(){
        onBtnDetailClick(this);
    });
    // Hàm xử lý khi ấn nút lọc
    $("#btn-filter").on("click", function(){
        onBtnFilterClick();
    });

    // Hàm ấn nút confirm order
    $("#button-confirm").on("click", function(){
        onBtnConfirmClick("confirm");
    });
    // Hàm ấn nút cancel order
    $("#button-cancel").on("click", function(){
        onBtnConfirmClick("cancel");
    });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    function onPageLoading(){
        "use strict";
        // Gọi Api
        const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        $.ajax({
            url: vBASE_URL,
            type: "GET",
            dataType: "json",
            success: function(response){
                console.log(response);
                gObjectUserData.user = response;
                loadDataTable(gObjectUserData.user)
               
            },
            error: function(response){
                alert("Gọi Api không thành công!");
            }
        });
    };
    // Hàm ấn nút chi tiết
    function onBtnDetailClick(paramElement){
        "use strict";
        const vArrayRow = 0;
        var vTable = $("#user-table").DataTable();
        var vNewRow = $(paramElement).closest("tr");
        var vData = vTable.rows(vNewRow).data();
        //console.log(vData);
        gObjectId.id = vData[vArrayRow].id;
        gObjectId.orderId = vData[vArrayRow].orderId;
        console.log(gObjectId);
        $("#modal-order-detail").modal("show");
        getImpurtDataModalDetail(gObjectId);
    };
    
    // Hàm ấn nút lọc dữ liệu
    function onBtnFilterClick(){
        "use strict";
        var vObjectFilter = {
            trangThai: "",
            loaiPizza: ""
        };
        // Bước 1: Thu thập dữ liệu
        getCollectDataFilter(vObjectFilter);
        // Bước 2: Kiểm tra dữ liệu

        // Bước 3: lọc dữ liệu
        var vDataFilter = gObjectUserData.filterUser(vObjectFilter);
        console.log(vDataFilter);
        // Bước 4: XỬ lý hiển thị
        loadDataTable(vDataFilter);
    }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
     // Hàm đổ dữ liệu vào bảng
     function loadDataTable(paramData){
        "use strict";
        gUserTable.clear();
        gUserTable.rows.add(paramData);
        gUserTable.draw();
     };

     // Hàm thu thập lọc dữ liệu
     function getCollectDataFilter(paramDataFilter){
         "use strict";
        paramDataFilter.trangThai = $("#select-order").val();
        paramDataFilter.loaiPizza = $("#select-pizza").val();
     };
     // Hàm đổ dữ liệu vào Modal
     function getImpurtDataModalDetail(paramData){
         "use strict";
         const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
         //gọi Api
        $.ajax({
            url: gBASE_URL + "/" + paramData.orderId,
            type: "GET",
            dataType: "json",
            success: function(response){
                //console.log(response);
                $("#inp-order-id").val(response.orderId);
                $("#inp-combo").val(response.kichCo);
                $("#inp-salad").val(response.salad);
                $("#inp-so-luong-nuoc").val(response.soLuongNuoc);
                $("#inp-suon").val(response.suon);
                $("#inp-loai-pizza").val(response.loaiPizza);
                $("#inp-duong-kinh").val(response.duongKinh);
                $("#inp-id-nuoc-uong").val(response.idLoaiNuocUong);
                $("#inp-thanh-tien").val(response.thanhTien);
                $("#inp-ho-ten").val(response.hoTen);
                $("#inp-so-dien-thoai").val(response.soDienThoai);
                $("#inp-email").val(response.email);
                $("#inp-dia-chi").val(response.diaChi);
                $("#inp-discount").val(response.giamGia);
                $("#inp-voucher").val(response.idVourcher);
                $("#inp-trang-thai").val(response.trangThai);
                $("#inp-loi-nhan").val(response.loiNhan);
                $("#inp-ngay-cap-nhat").val(response.ngayCapNhat);
                $("#inp-ngay-tao").val(response.ngayTao);
            },
            error: function(response){
                alert("Gọi Api không thành công")
            }
        })
     };
     
     // Hàm xử lý xác nhận đơn hàng
     function onBtnConfirmClick(paramStatus){
         "use strict";
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
            // Bước 1: thu thập thông tin
            //console.log(gObjectId.id)
            //console.log("đã vào")
            var vObjectStatus = {
                trangThai: paramStatus,
                
            }
            // Bước 2: Kiểm tra thông tin

            // Bước 3: Gọi Api
            $.ajax({
                url: vBASE_URL + "/" + gObjectId.id,
                type: "PUT",
                contentType: "application/json",
                data: JSON.stringify(vObjectStatus),
                success: function(response){
                    console.log(response);
                    alert("Cập nhật dữ liệu thành công!");
                    location.reload();
                },
                error: function(){
                    alert("Gọi Api không thành công!")
                }

            })
        }

  })
</script>
</html>